--
-- Vario700Anim
-- Specialization FAN class for Vario700Anim
-- V1.0
-- @author  Ago-Systemtech
-- @date  26/06/2015
-- Copyright (C)Ago-Systemtech, All Rights Reserved.
----modifing for open-close door
-- --by Clod @ TIF-http://forum.tractor-italia.net
--	for use this specialization on your mods...
-- 	@ Ago-Systemtech: https://www.facebook.com/ago.systemtech (Modhoster Team)
--	free for non commercial-usage! -------------
Vario700Anim = {};
function Vario700Anim.prerequisitesPresent(specializations)
    return true;
end;
function Vario700Anim:load(xmlFile)
	self.skipAnimation = SpecializationUtil.callSpecializationsFunction("skipAnimation");
	self.onEnterAnimRootNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.onBoard#rootNode"));
    self.onEnterAnimCharSet = 0;
    if self.onEnterAnimRootNode ~= nil and self.onEnterAnimRootNode ~= 0 then
        self.onEnterAnimCharSet = getAnimCharacterSet(self.onEnterAnimRootNode);
        if self.onEnterAnimCharSet ~= 0 then
            local clip = getAnimClipIndex(self.onEnterAnimCharSet, getXMLString(xmlFile, "vehicle.onBoard#clip"));
            assignAnimTrackClip(self.onEnterAnimCharSet, 0, clip);
            setAnimTrackLoopState(self.onEnterAnimCharSet, 0, false);
            local onEnterAnimSpeedScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.onBoard#speedScale"), 1);
			setAnimTrackSpeedScale(self.onEnterAnimCharSet, 0, onEnterAnimSpeedScale);
            self.onEnterAnimDuration = getAnimClipDuration(self.onEnterAnimCharSet, clip);
        end;
    end;
	self.hasPlayedOnEnter = true;
	self.hasOpenedDoor = false;
	self.hasEntered = false;
	-----------door sound------------
	openSoundFile = Utils.getFilename("Sound/closeDoor.wav", self.baseDirectory);
    self.openDoorSoundId = createSample("Cldoorsound");
    loadSample(self.openDoorSoundId, openSoundFile, false);
    self.openPlaying = false;
	clouseSoundFile = Utils.getFilename("Sound/openDoor.wav", self.baseDirectory);
    self.clouseDoorSoundId = createSample("Opdoorsound");
    loadSample(self.clouseDoorSoundId, clouseSoundFile, false);
    self.clousePlaying = false
	local oSX = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.osx#index"));
    if oSX ~= nil then
        self.osx = {};
        self.osx.node = oSX;
		end;
	local oRX = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.orx#index"));
    if oRX ~= nil then
        self.orx = {};
        self.orx.node = oRX;
		end;			
    local tSUP = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tsup#index"));
    if  tSUP~= nil then
        self.tsup = {};
        self.tsup.node = tSUP;
		end;
end;
function Vario700Anim:delete()
end;
function Vario700Anim:readStream(streamId, connection)
end;
function Vario700Anim:writeStream(streamId, connection)
end;
function Vario700Anim:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
     return BaseMission.VEHICLE_LOAD_OK;
end;
function Vario700Anim:mouseEvent(posX, posY, isDown, isUp, button)
end;
function Vario700Anim:keyEvent(unicode, sym, modifier, isDown)
end;
if g_currentModName ~= "FENDT_VARIO700_SCR_COL_FS15_AGO_RC1" then
	while g_currentModName ~= "FENDT_VARIO700_SCR_COL_FS15_AGO_RC1" do
	print("Restore the correct name ... you were wrong !!");
	end;
end;
function Vario700Anim:update(dt)
if  self:getIsActiveForInput() then
		local x, y, z = getRotation(self.osx.node);
			if y < Utils.degToRad(1) and y > Utils.degToRad(0.01)  then
			self.soundOpen = true;
			self.soundClose = false;
			else
			if y > Utils.degToRad(1) and y < Utils.degToRad(3)  then
			self.soundOpen = false;
			self.soundClose = true;
			end;
			end;
		local xz, yz, zz = getRotation(self.orx.node);
			if xz < Utils.degToRad(1) and  xz > Utils.degToRad(0.01) then
			self.soundOpen = true;
			self.soundClose = false;
			else
			if xz > Utils.degToRad(1) and xz < Utils.degToRad(3)  then
			self.soundOpen = false;
			self.soundClose = true;
			end;
			end;
		local xt, yt, zt = getRotation(self.tsup.node);
			if xt < Utils.degToRad(1) and  xt > Utils.degToRad(0.01) then
			self.soundOpen = true;
			self.soundClose = false;
			else
			if xt > Utils.degToRad(1) and xt < Utils.degToRad(3)  then
			self.soundOpen = false;
			self.soundClose = true;
			end;
			end;				
	  	end;	  
	if self.setAnimationTime ~= nil then
		if self.dCcheckModule ~= nil 
				and self.driveControl  ~= nil
				and self:dCcheckModule("handBrake")
				and self.driveControl.handBrake.isActive then
			self:setAnimationTime(2, 1);
		else
			self:setAnimationTime(2, 0);
		end;
	end;
	if self.soundOpen then
       if not self.openPlaying then
            playSample(self.openDoorSoundId, 1, 3, 3);
            self.openPlaying = true;
        end;
    else
        if self.openPlaying then
            stopSample(self.openDoorSoundId);
            self.openPlaying = false;
        end;
    end;
	if self.soundClose then
       if not self.clousePlaying then
            playSample(self.clouseDoorSoundId, 1, 3, 3);
            self.clousePlaying = true;
        end;
    else
        if self.clousePlaying then
            stopSample(self.clouseDoorSoundId);
            self.clousePlaying = false;
        end;
		end;
-------------------------------------------------------------------------------
		if self.hasPlayedOnEnter == false then
		if self.hasOpenedDoor == false then
			if self.interactiveObjects[5].isOpen == false then
				self.interactiveObjects[5].isOpen = true;
				if self.interactiveObjects[5].animation.animCharSet ~= 0 then
					if getAnimTrackTime(self.interactiveObjects[5].animation.animCharSet, 0) < 0.0 then
						setAnimTrackTime(self.interactiveObjects[5].animation.animCharSet, 0, 0.0);
					end;
					setAnimTrackSpeedScale(self.interactiveObjects[5].animation.animCharSet, 0, self.interactiveObjects[5].animation.animSpeedScale);
					enableAnimTrack(self.interactiveObjects[5].animation.animCharSet, 0);
				end;
			end;
			if getAnimTrackTime(self.interactiveObjects[5].animation.animCharSet, 0) > self.interactiveObjects[5].animation.animDuration then
				self.hasOpenedDoor = true;
			end;
		end;
		if self.hasOpenedDoor then
			if self.onEnterAnimCharSet ~= 0 then
				if getAnimTrackTime(self.onEnterAnimCharSet, 0) < 0.0 then
					setAnimTrackTime(self.onEnterAnimCharSet, 0, 0.0);
				end;
				setAnimTrackSpeedScale(self.onEnterAnimCharSet, 0, 1);
				enableAnimTrack(self.onEnterAnimCharSet, 0);
			end;
			if getAnimTrackTime(self.onEnterAnimCharSet, 0) > self.onEnterAnimDuration then
				self.hasEntered = true;
			end;
		end;
		if self.hasEntered then
			self.interactiveObjects[5].isOpen = false;
			if self.interactiveObjects[5].animation.animCharSet ~= 0 then
				if getAnimTrackTime(self.interactiveObjects[5].animation.animCharSet, 0) > self.interactiveObjects[5].animation.animDuration then
					setAnimTrackTime(self.interactiveObjects[5].animation.animCharSet, 0, self.interactiveObjects[5].animation.animDuration);
				end;
				setAnimTrackSpeedScale(self.interactiveObjects[5].animation.animCharSet, 0, -self.interactiveObjects[5].animation.animSpeedScale);
				enableAnimTrack(self.interactiveObjects[5].animation.animCharSet, 0);
			end;
			self.hasPlayedOnEnter = true;
		end;
		if InputBinding.hasEvent(InputBinding.SKIP_ANIMATION) then
			self:skipAnimation();
		end;
	end;
end;
function Vario700Anim:draw()
	if not self.hasPlayedOnEnter then
		g_currentMission:addHelpButtonText(string.format(g_i18n:getText("SKIP_ANIMATION"), self.typeDesc), InputBinding.SKIP_ANIMATION);
	end;
end;
function Vario700Anim:stopSounds()
end;
function Vario700Anim:startMotor()
end;
function Vario700Anim:stopMotor()
end;
function Vario700Anim:skipAnimation()
	self.hasEntered = true;
	disableAnimTrack(self.onEnterAnimCharSet, 0);
	setAnimTrackTime(self.onEnterAnimCharSet, 0, 8500.0);
	setTranslation(self.onEnterAnimRootNode, 0, 0, 0);
	setRotation(self.onEnterAnimRootNode, math.rad(0), math.rad(180), math.rad(0));
end;
function Vario700Anim:onEnter()
	self.hasPlayedOnEnter = false;
end;
function Vario700Anim:onLeave()
	self.hasEntered = false;
	self.hasOpenedDoor = false;
	self.hasPlayedOnEnter = true;
	disableAnimTrack(self.onEnterAnimCharSet, 0);
	setAnimTrackTime(self.onEnterAnimCharSet, 0, 0.0);
	setTranslation(self.onEnterAnimRootNode, 2.07, -0.8, 0.91);
	setRotation(self.onEnterAnimRootNode, math.rad(0), math.rad(90), math.rad(0));	
end;